public class TestableObject extends TestableObjectBase
{
  @Override
  protected boolean triangleContainmentIsFaulty()
  {
    return true;
  }
  private static int min(int a,int b,int c){
    return(Math.min(Math.min(a,b),c));
  }
  private static int max(int a,int b,int c){
    return(Math.max(Math.max(a,b),c));
  }
  @Override
  protected boolean triangleContains(int x1, int y1, int x2, int y2, int x3, int y3, int xtest, int ytest)
  {
    // We consider the bounding box of the triangle instead of the triangle itself.
    int xmin = min(x1, x2, x3);
    int xmax = max(x1, x2, x3);
    int ymin = min(y1, y2, y3);
    int ymax = max(y1, y2, y3);
    return xtest <= xmax && xtest >= xmin && ytest <= ymax && ytest >= ymin;
  }
  @Override
  protected boolean editDistanceIsFaulty()
  {
    return true;
  }
  @Override
  protected int editDistance(String first, String second)
  {
    // Deleting the first string and replacing it by the second string is a valid edit distance, just not the shortest one.
    return first.length() + second.length();
  }
  @Override
  protected boolean kromFormulaIsFaulty()
  {
    return true;
  }
  @Override
  protected boolean kromFormula(int variables, KromClause[] formula)
  {
    // We just check for X OR NOT X, which has nothing to do with the satisfiability of Krom clauses.
    for (int i = 0; i < formula.length; i++)
    {
      if (formula[i].getVar1() == formula[i].getVar2()
          &&
          formula[i].getIsPositive1() != formula[i].getIsPositive1())
      {
        return true;
      }
    }
    return false;
  }
}























































